<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\CustomerData;

use Magento\Customer\CustomerData\SectionSourceInterface;

class GeoipData implements SectionSourceInterface {

    protected $_helper;
    protected $_scopeConfig;
    protected $_storeManager;

    public function __construct(
    \FiloBlu\ExtAmastyGeoipRedirect\Helper\Data $helper,
            \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
            \Magento\Store\Model\StoreManagerInterface $storeManager
    ) {
        $this->_helper = $helper;
        $this->_scopeConfig = $scopeConfig;
        $this->_storeManager = $storeManager;
    }

    /**
     * {@inheritdoc}
     */
    public function getSectionData() {
        return [
            "current_country_code" => $this->getCurrentCountryCode(),
            "current_country_name" => $this->getCurrentCountryName(),
            "current_store_url" => $this->_storeManager->getStore()->getBaseUrl(),
            "current_store_id" => $this->_storeManager->getStore()->getId(),
        ];
    }

    private function getCurrentCountryCode() {
        return ($this->_helper->getCountryCookie() ? $this->_helper->getCountryCookie() : $this->scopeConfig->getValue('general/country/default', \Magento\Store\Model\ScopeInterface::SCOPE_STORE));
    }

    public function getCurrentCountryName() {
        return $this->_helper->getCountryName($this->getCurrentCountryCode());
    }

}
